#ifndef CHEADER_MOTOR
# define CHEADER_MOTOR
typedef struct
{
    long    Setpoint;           // 24.8 number
    long    Encoder;            // Current position
    int8_t  Kp;
    int8_t  Kd;
    int8_t  Td;
    int8_t  Ki;
    int8_t  Ko;                 // Output Scale
    int16_t PrevErr;
    int16_t Ierror;
    int16_t Velocity;
    int16_t VelocitySetpoint;
    int16_t Acceleration;
} MotorInfo, * pMotorInfo;

#define MAXOUTPUT 0x7F

extern MotorInfo Left, Right;
extern float X, Y, Theta;
extern int iX, iY, iTheta;      // Integers in 1/10" increment
extern Mutex MotorLoop;

void AddToPosition(pMotorInfo, int16_t);

#endif //CHEADER_MOTOR
