/*
    LCD control routine header
*/
#ifndef LCDIO_HEADER
#  define LCDIO_HEADER

#include "lcd.inc"

uint8_t lcd_rd_data(void);
uint8_t lcd_rd_inst(void);
void lcd_wr_data(uint8_t);
void lcd_put_char(uint8_t);
void lcd_wr_inst(uint8_t);

void lcd_GetDisplay(void);
void lcd_ReleaseDisplay(void);
void lcd_PutHex(uint16_t, uint8_t);
void lcd_PutHexWord(uint16_t);
void lcd_PutHexByte(uint16_t);
void lcd_PutHexChar(uint16_t);
void lcd_putstr(const char *);
void lcd_PrintMessageAt(const char *, uint8_t);
void lcd_EraseToEndOfLine(void);

void lcd_4_init();

extern Mutex lcdmutex;

#define lcd_setcursor(A) lcd_wr_inst((A) | LCD_SET_DDRAM)

#endif  // LCD_HEADER

