/*
File:   Serialio.asm

Copyright 1998, 1999 Larry Barello

*/
#include        "Hardware.h"
#include        "avrx.inc"
#include        "myctoasm.inc"

        .comm   _GetHexNumChar, 1
        .section .text
;+
;------------------------------------------
;
; PutCR
;
; Put a CR to the output stream
;-
        .func PutCR
        .global PutCR
PutCR:
        ldi     p1b, 0x0D
        rjmp    putchar
        .endfunc
;+
;------------------------------------------
;
; PutSpace
;
; Put a space to the output stream
;-
        .func PutSpace
        .global PutSpace
PutSpace:
        ldi     p1b, ' '
        rjmp    putchar
        .endfunc


;-----------------------------------------
; GetHexWord
;
        .func GetHexWord
        .global GetHexWord
GetHexWord:
        ldi     p1b, 4
        rjmp    GetHex
        .endfunc
;-----------------------------------------
; GetHexByte
;
        .func GetHexByte
        .global GetHexByte
GetHexByte:
        ldi     p1b, 2
        rjmp    GetHex
        .endfunc

;-----------------------------------------
; GetHexByte
;
        .func GetHexChar
        .global GetHexChar
GetHexChar:
        ldi     p1b, 1
        rjmp    GetHex
        .endfunc

;-----------------------------------------
; void _PutHex(unsigned val, char numdigits)
; 
; Passed:       R24:25 = Value, R22 = # digits
; RETURN:       Nothing
; USES:         
; STACK:        2
;
        .func   _PutHex
        .global _PutHex
_PutHex:
        push    R8
        push    R9
        push    R28
        push    R29
        mov     R8, p1wl
        mov     R9, p1wh
        mov     R28,p2b
        ldi     R29, 4          ; Maximum number of digits.
ph00:
        lsl     R8
        rol     R9
        rol     p1b
        lsl     R8
        rol     R9
        rol     p1b
        lsl     R8
        rol     R9
        rol     p1b
        lsl     R8
        rol     R9
        rol     p1b

        cp      R28, R29
        brlt    ph02

        cbr     p1b, 0xF0
        subi    p1b, -'0'            ; Addi '0'
        cpi     p1b, ('9' + 1)       ; if > '9'
        brlt    ph01                 ; subi '9' and add 'A'
        subi    p1b, ('9' + 1 - 'A')
ph01:   
        rcall   putchar
ph02:   
        dec     R29
        brne    ph00

        pop     R29
        pop     R28
        pop     R9
        pop     R8
        ret
        .endfunc
        
;-----------------------------------------
; Put out a hex word
; 
; Passed: Y = word
;
        .func   PutHexWord
        .global PutHexWord
PutHexWord:
        ldi     p3b, 4
        rjmp    _PutHex
        .endfunc

;-----------------------------------------
; Put out a two ascii hex byte
; Yl = byte
;
        .func   PutHexByte
        .global PutHexByte
PutHexByte:
        ldi     p3b, 2
        rjmp    _PutHex
        .endfunc

